ll.registerPlugin("OD_display", "统计玩家在线时长", [1, 0, 0], {
    "author": "aabb",
    "info": "讨论群聊: 344432884",
    "version": "1.0.0",
    "description": "统计玩家在线时长"
});

function sendform(player) {
    let fm = mc.newSimpleForm()
    let data = new JsonConfigFile("./plugins/OD_display/data.json")
    let times = data.get(player.realName)
    fm.setTitle("§d§l在线时长统计")
    let data2 = File.readFrom("./plugins/OD_display/data.json")
    fm.setContent(`§b玩家名: ${player.realName}\n§b在线时长: §a${times} 分钟\n§e-----------在线排行榜-----------\n${formatPlayerData(data2)}`)
    fm.addButton("§l我 知 道 了")
    player.sendForm(fm,function (player, data) {
    });
}

function formatPlayerData(data) {
    let data3 = JSON.parse(data);
    const sortedPlayers = Object.entries(data3)
        .sort((a, b) => b[1] - a[1])
        .map(([name, duration]) => `§l${name}: §r§7${duration} 分钟`);
    const result = sortedPlayers.join('\n');
    return result;
}

function updata() {
    let config = new JsonConfigFile("./plugins/OD_display/config/config.json")
    let data = new JsonConfigFile("./plugins/OD_display/data.json")
    let allplayer = mc.getOnlinePlayers()
    allplayer.forEach((player) => {
        let ob = mc.getScoreObjective(config.get("ScoredName"))
        let score = ob.getScore(player)
        data.set(player.realName,score)
    });
}

mc.listen("onJoin", (player) => {
    let data = new JsonConfigFile("./plugins/OD_display/data.json")
    data.init(player.realName, 0)
})

mc.listen("onServerStarted", () => {
    try {
        let config = new JsonConfigFile("./plugins/OD_display/config/config.json")
        let cmdname = config.get("cmd")
        let cmd = mc.newCommand(cmdname,"查询在线时长",PermType.Any)
        cmd.setCallback((_cmd, ori, out, _res) => {
            let player = ori.player;
            sendform(player);
    });
   cmd.overload([])
   cmd.setup()
   if (config.get("TimerType") == 1) {
    setInterval(() => {
        let allplayer = mc.getOnlinePlayers()
        if (allplayer.length !== 0) {
            allplayer.forEach((player) => {
                let data = new JsonConfigFile("./plugins/OD_display/data.json")
                data.set(player.realName, data.get(player.realName) + 1)
            })
        }
    }, 60000)
   } else {
    setInterval(updata, 60000)
   }
    logger.info("在线时长命令注册成功！")
    } catch (error) {
        logger.error("在线时长命令注册失败" + error)
    }
})